	section bmpload

	xdef wl_bmpload

************************************************************
*
*		BMPLOAD[#chan%],name_of_file$
*
* this loads an image file into mem
* image file must be in special format:
*	word : x size
*	word : ysize
*	words: the image data, 2 bytes per pixel, mode 32 (QPC) format
* v. 1.00
*
*  2002 Mar 16 07:49:49
*
* (c) w. lenerz 2002
*
* BEWARE	this does no clipping
* MAKE SURE the image fits in the channel
*
************************************************************


XJSR	macro	name
	xref	[name]		; - makes external jump
	JSR	[name]
	endm

DTRAP	macro	nbr,name
	TRAP	#[nbr]		; trap with error check
	TST.L	D0
	BNE	[name]
	endm




space	EQU	$400
fsize	EQU	8		; total file size
offset	EQU	$a		; offset to bitmap data
hsize	EQU	$E		; header size
width	EQU	$12		; x size of file is here (pixels)
height	EQU	$16		; y size of file is here (pixels)
planes	EQU	$1a		; nbr of planes
type	EQU	$1C		; type of bitmap, must be 24 for 24 bit image
compress	EQU	$1E		; type of compression
size	EQU	$22		; Size of the bitmap data in bytes. This number must be rounded to the next 4 byte boundary
nbcol	EQU	$2e		; nbr of cols used
impcol	EQU	$32		; nbr of important colours (?!)
hlen	EQU	$36		; header length, here starts the data (or palette)



; first get the input filename, open file & load image into mem
wl_bmpload			; stupid macro!
	XJSR	chan_num	; get channel ID, default to #1
	BNE	bmp_out 	; oops
	MOVE.L	A0,A2		; keep channel ID
	MOVE.L	#space,D0	; get string from basic, into space
	XJSR	cpy_str 	; pointed then by A0
	BNE	bmp_out 	; oops!
	MOVE.L	A0,A4		; keep pointer to filename space
	MOVEQ	#1,D3		; shared access
	MOVEQ	#1,D0
	MOVEQ	#-1,D1
	DTRAP	2,bmp_out2	; open file
	MOVE.L	A4,A1		; point space for file header
	MOVE.L	#space,D2
	MOVEQ	#$47,D0
	MOVEQ	#-1,D3
	DTRAP	3,bmp_out2	; read file header
	MOVE.L	(A4),D5 	; length of file
	EXG	A0,A4
	XJSR	gu_rchp 	; release mem for filename
	MOVE.L	D5,D0		; length of file
	XJSR	gu_achp 	; get mem for the file
	BNE	bmp_out3		; oops->... (file stays open!!!)
	EXG	A0,A4		; A0 = channel ID, A4 = memptr
	MOVE.L	A4,A1		; point to space for file
	MOVE.L	D5,D2
	MOVEQ	#$48,D0 	; greek goddess (scatter load file)
	DTRAP	3,bmp_out2
	MOVEQ	#2,D0
	TRAP	#2		; close input file now

	MOVE.L	A2,A0		; point to channel ID given as parameter
	LEA	xtop,A2
	SUB.L	#16,A7
	MOVE.L	A7,A1
	MOVEQ	#9,D0
	TRAP	#3		; do external OP


pt_scren equ	$e8    ; long  address of visible SCREeN
pt_scrsz equ	$ec    ; long  SCReen SiZe in bytes
pt_scinc equ	$f0    ; word  SCreen row INCrement (nbr nytes/line)
pt_xscrs equ	$f2    ; word  X SCReen Size in pixels
pt_yscrs equ	$f4    ; word  Y SCReen Size in pixels



	MOVEQ	#0,D1
	MOVEQ	#0,D2
	MOVEQ	#$6F,D0 	; pretend to set bytes in linkage block
	TRAP	#3
	TST.L	D0
	BNE.S	r_out
	CLR.L	D6
	MOVE.W	pt_scinc(A1),D6
	MOVE.L	D6,D4		; scr_llen (nbr of bytes per line)
	MOVE.W	pt_xscrs(A1),D5
	DIVS.W	D5,D6		; nbr of bytes/pixel
	TST.W	D6
	BEQ.S	no_good 	; there must be at least 1 byte/pixel!


	MOVE.L	A4,A0		; keep mem pointer
	MOVE.L	8(A7),A1		; point to screen base
	MOVE.W	4(A7),D0		; channel xorig
	MULU	D6,D0
	ADD.L	D0,A1
	MOVE.W	6(A7),D0		; channel Y orig
	MULU	D4,D0
	ADD.L	D0,A1
	MOVE.L	(A7),D0 	; channel x,y size
	MOVE.W	2(A0),D2		; image y size
	CMP.W	D2,D0
	BGE.S	y_ok
	MOVE.W	D0,D2
y_ok	MOVE.W	(A0),D1 	; image x size
	MOVE.W	D1,D3
	MULU	D6,D3
	SWAP	D0
	CMP.W	D1,D0
	BGE.S	x_ok
	MOVE.W	D0,D1
x_ok	SUBQ.W	#1,D1
	SUBQ.W	#1,D2
	ADDQ.L	#4,A0
lp1	MOVE.L	A1,A3
	MOVE.L	A0,A2
	MOVE.W	D1,D0
lp2	MOVE.W	(A2)+,(A3)+
	DBF	D0,lp2
	ADD.L	D4,A1
	ADD.W	D3,A0
	DBF	D2,lp1
	ADD.L	#16,A7
	CLR.L	D0
bmp_out2	MOVE.L	A4,A0
	XJSR	gu_rchp
bmp_out RTS
bmp_out3	MOVEQ	#2,D0
	TRAP	#2
	BRA.S	bmp_out2


no_good MOVEQ	#-15,D0
r_out	ADD.L	#16,A7
	BRA.S	bmp_out

xtop	MOVE.L	$1C(A0),(A1)	; size	4
	MOVE.L	$18(A0),4(A1)	; orig	8
	MOVE.L	$32(A0),8(A1)	; screen_base
	RTS
	end
